import { get } from 'svelte/store';
import { displayMessage, translateError } from './stores/messages.store';

export const popupFormErrors = (form?: { errors?: string[] } | null, prefix?: string) => {
	if (form?.errors) {
		form.errors.forEach((error) =>
			displayMessage({
				text: get(translateError)(error, prefix),
				type: 'error'
			})
		);
	}
};
