export class ApiUtils {
	static redirect(url: string, status = 302): Response {
		return new Response(null, {
			status,
			headers: {
				Location: url
			}
		});
	}

	static async getJsonOrFormBody(request: Request) {
		try {
			if (request.headers.get('content-type')?.startsWith('application/json')) {
				const jsonBody = await request.json();
				return jsonBody;
			}

			const formBody = await request.formData();
			return Object.fromEntries(formBody);
		} catch {
			return {};
		}
	}
}
