import type { RequestEvent } from '@sveltejs/kit';

export enum AuditAction {
	LOGIN = 'login',
	REGISTRATION = 'registration',
	USER_UPDATE = 'user_update',
	USER_DELETE = 'user_delete',
	TOTP_ACTIVATE = 'totp_activate',
	TOTP_DEACTIVATE = 'totp_deactivate',
	PASSWORD_CHANGE = 'password_change',
	EMAIL_CHANGE = 'email_change',
	MALICIOUS_REQUEST = 'malicious_request',
	THROTTLE = 'throttle',
	DEACTIVATION_REQUEST = 'deactivation_request',
	DATA_DOWNLOAD_REQUEST = 'data_download_request',
	OAUTH2_CREATE = 'oauth2_create',
	OAUTH2_DELETE = 'oauth2_delete',
	OAUTH2_UPDATE = 'oauth2_update',
	OAUTH2_REGENERATE = 'oauth2_regenerate',
	OAUTH2_INVITE = 'oauth2_invite'
}

export type MinimalRequestEvent = Pick<RequestEvent, 'getClientAddress' | 'request'>;

export interface AuditSearchClause {
	actions?: AuditAction[] | string;
	user?: string;
	ip?: string;
	ua?: string;
	content?: string;
	flagged?: boolean;
}

export interface AuditListItem {
	id: number;
	action: AuditAction;
	user?: {
		uuid: string;
		name: string;
	};
	ip?: string;
	ua?: string;
	content?: string;
	flagged: boolean;
	created_at: Date;
}
