export class Changesets {
	/**
	 * @deprecated use `Changesets.only`
	 */
	static take<TRes>(
		fields: (keyof TRes)[],
		body: FormData | URLSearchParams,
		challenge?: Partial<TRes>
	): Partial<TRes> {
		return fields.reduce<Partial<TRes>>((accum, field) => {
			accum[field] = challenge
				? challenge[field]
				: ((body.get(field as string) as string)?.trim() as TRes[typeof field]);
			return accum;
		}, {});
	}

	static only<KeyList extends string, ResultObject extends Record<KeyList, string | undefined>>(
		fields: KeyList[],
		body: FormData | URLSearchParams,
		challenge?: ResultObject
	): ResultObject {
		return fields.reduce<ResultObject>((accum, field) => {
			accum[field] = challenge
				? challenge[field]
				: ((body.get(field as string) as string)?.trim() as ResultObject[typeof field]);
			return accum;
		}, {} as ResultObject);
	}
}
