import { FileBackend } from '$lib/server/file-backend.js';
import { Uploads } from '$lib/server/upload.js';

export async function GET({ params: { uuid } }) {
	const uploadFile = await Uploads.getClientAvatarById(uuid);
	if (!uploadFile) {
		const fallback = await Uploads.getClientFallback();
		return new Response(fallback, {
			status: 200,
			headers: {
				'Content-Type': 'image/png',
				'Cache-Control': 'max-age=3600'
			}
		});
	}

	const readUpload = await FileBackend.readFile([Uploads.uploads, uploadFile.file]);
	return new Response(readUpload, {
		status: 200,
		headers: {
			'Content-Type': uploadFile.mimetype,
			'Cache-Control': 'max-age=3600'
		}
	});
}
